CON
_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000

rxpin = 31 ' Receive on I/O pin 1 <- black from master black txpin p1 
txpin = 30 ' Transmit on I/O pin 0 -> red to master red rxpin p0
ServoCh1 = 20  'Steering servo                            
ServoCh2 = 16
VAR

  LONG SerStack[32]
  LONG TransmitStack[32]
  LONG txVal_1, txVal_2, rtVal_3, txVal_4 ' transmit
  LONG rxVal_1, rxVal_2, rxVal_3, rxVal_4' receive from master and PST
  LONG rxVal
  LONG HeadingX
  LONG HeadingY

{************************************************* *****************} 
OBJ

  serial : "Extended_FDSerial" '' "FullDuplexSerial"
  f : "Float32Full" 
  SERVO : "Servo32v7.spin"
 
PUB Main | DutyCycle ' new stuff DutyCycle
  
  SERVO.Start                                             'Start Servo handler
  SERVO.Ramp  '<-OPTIONAL                                 'Start Background Ramping
  serial.start(rxpin,txpin,%0000, 38400)                  '- rxpin,txpin,mode,Baud
  cognew(SerCog, @SerStack)                               'Start new cogs
  cognew(Transmitter, @TransmitStack)

  

    repeat
      SerCog                                            'receive data from roborealm
      Transmitter                                       'Send data from roborealm back to RR
      HeadingX := 1340 + rxVal_1                        'convert data to pulsewidth X
      HeadingY := 1380 + rxVal_2                        'convert data to pulsewidth Y
      SERVO.SetRamp(ServoCh1,HeadingX,100)              'Output to servo
      SERVO.SetRamp(ServoCh2,HeadingY,100)
    
        
PUB SerCog 

    rxVal_1 := serial.rx 
    rxVal_2 := serial.rx 
    rxVal_3 := serial.rx 
    rxVal_4 := serial.rx 

    rxVal := rxVal_1 | (rxVal_2<<8) | (rxVal_3<<16) | (rxVal_4<<24) 

PUB Transmitter

    serial.dec(rxVal_1 | (rxVal_2<<8) | (rxVal_3<<16) | (rxVal_4<<24))
    serial.tx(13)
